[POJ 3311] Hie with the Pie【状压DP】
Problem:
Time Limit: 2000MS | Memory Limit: 65536K |
Description
The Pizazz Pizzeria prides itself in delivering pizzas to its customers as fast as possible. Unfortunately, due to cutbacks, they can afford to hire only one driver to do the deliveries. He will wait for 1 or more (up to 10) orders to be processed before he starts any deliveries. Needless to say, he would like to take the shortest route in delivering these goodies and returning to the pizzeria, even if it means passing the same location(s) or the pizzeria more than once on the way. He has commissioned you to write a program to help him.
Input
Input will consist of multiple test cases. The first line will contain a single integer n indicating the number of orders to deliver, where 1 ≤ n ≤ 10. After this will be n + 1 lines each containing n + 1 integers indicating the times to travel between the pizzeria (numbered 0) and the n locations (numbers 1 to n). The jth value on the ith line indicates the time to go directly from location i to location j without visiting any other locations along the way. Note that there may be quicker ways to go from i to j via other locations, due to different speed limits, traffic lights, etc. Also, the time values may not be symmetric, i.e., the time to go directly from location i to j may not be the same as the time to go directly from location j to i. An input value of n = 0 will terminate input.
Output
For each test case, you should output a single number indicating the minimum time to deliver all of the pizzas and return to the pizzeria.
Sample Input
3 0 1 10 10 1 0 1 2 10 1 0 10 10 2 10 0 0
Sample Output
8
Source
Solution:
竟然又一头撞上大水题。。
由于可以重复经过点,所以两点之间边的关系并不重要,只有两点之间的最短路对答案有影响。
所以只要将走过的点集进行状态压缩,跑一下 DP 就可以了。
实际上这道题是[POJ 2288] Islands and Bridges【状压DP】的简化版。。
Code: O(n3+2nn2) [852K, 0MS]
#include<cstdio> #include<cstdlib> #include<cstring> #include<cmath> #include<iostream> #include<algorithm> using namespace std; typedef long long ll; int n, dis[12][12], S; ll dp[2100][12]; inline void Floyd(){ for(register int k = 0; k <= n; k++) for(register int i = 0; i <= n; i++) for(register int j = 0; j <= n; j++) dis[i][j] = min(dis[i][j], dis[i][k] + dis[k][j]); } int main(){ while(scanf("%d", &n) != EOF && n){ for(register int i = 0; i <= n; i++) for(register int j = 0; j <= n; j++) scanf("%d", &dis[i][j]); Floyd(); memset(dp, 0x3f, sizeof(dp)); S = 1 << n + 1; for(register int i = 1; i <= n; i++) dp[1 << i][i] = dis[0][i]; for(register int s = 0; s < S; s++) for(register int i = 0; i <= n; i++) if(s & 1 << i){ int s_ = s ^ 1 << i; for(register int j = 0; j <= n; j++) if(s_ & 1 << j) dp[s][i] = min(dp[s][i], dp[s_][j] + dis[j][i]); } printf("%lld\n", dp[S - 1][0]); } return 0; }
发表评论